// ExportZDTable.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <Windows.h>
#include<iostream>
#include<fstream>
#include<string>
#include "aeroTAP_CAM\aeroTAP_SDK.h"

using namespace std;

AERO_IsCameraConnected g_pAERO_IsCameraConnected = NULL;
InitAeroCam g_pInitAeroCam = NULL;
ExitAeroCam g_pExitAeroCam = NULL;
AERO_SetResolution g_pAERO_SetResolution = NULL;
AERO_LoadZDTable g_pAERO_LoadZDTable = NULL;
AERO_GetPID g_pAERO_GetPID = NULL;

HINSTANCE m_hAeroTAPSDK;

int m_nZDTableLen = 0;
int m_nZDTable[2048];

int main(int argc, char** argv)
{
	const char* deviceRES = "VGA";
	int nCamNo = 0;
	if (argc < 2)
	{
		printf("%s /RESOLUTION /CamNo", argv[0]);
		printf("\r\n\r\nRESOLUTION: QVGA or VGA or WVGA");
		printf("\r\nCamNo: 0 - 2");
		exit(0);
	}
	deviceRES = argv[1]+1;
	if (argc > 2)
	{
		nCamNo = atoi(argv[2]+1);
	}

	m_hAeroTAPSDK = LoadLibrary(_T("aeroTAP_CAM.dll"));
	if (m_hAeroTAPSDK)
	{
		g_pAERO_IsCameraConnected = (AERO_IsCameraConnected)GetProcAddress(m_hAeroTAPSDK, "AERO_IsCameraConnected");

		g_pInitAeroCam = (InitAeroCam)GetProcAddress(m_hAeroTAPSDK, "InitAeroCam");
		g_pExitAeroCam = (ExitAeroCam)GetProcAddress(m_hAeroTAPSDK, "ExitAeroCam");
		g_pAERO_SetResolution = (AERO_SetResolution)GetProcAddress(m_hAeroTAPSDK, "AERO_SetResolution");
		g_pAERO_LoadZDTable = (AERO_LoadZDTable)GetProcAddress(m_hAeroTAPSDK, "AERO_LoadZDTable");
		g_pAERO_GetPID = (AERO_GetPID)GetProcAddress(m_hAeroTAPSDK, "AERO_GetPID");

		if (g_pInitAeroCam)
		{
			if (g_pAERO_IsCameraConnected)
			{
				if (!g_pAERO_IsCameraConnected())
				{
					printf("Please connect aeroTAP 3D USB Camera to run!");
					return -1;
				}
			}


			int nMode = 0;
			if (!g_pInitAeroCam(NULL, nCamNo*10, -1, 30, (void*)NULL, (void*)NULL, NULL, nMode))
			{
				printf("Error Initilizing aeroTAP Camera!");
			}
			else
			{
				char szPID[8];
				g_pAERO_GetPID(szPID);
				int nPID = atoi(szPID);

				printf("Found aeroTAP 3D USB Camera PID %d.\r\n",nPID);

				BOOL bRet = FALSE;
				if (strcmp(deviceRES, "QVGA") == 0)
				{
					if ((int)(nPID / 100) == 1)
					{
						printf("Setting resolution to QVGA\r\n");
						bRet = g_pAERO_SetResolution(nCamNo, 320, 240);
						if ( !bRet )
						printf("Setting resolution error\r\n");
					}
				}
				else
				if (strcmp(deviceRES, "WVGA") == 0)
				{
					if (nPID == 110 || nPID == 111)
					{
						printf("Setting resolution to WVGA\r\n");
						bRet = g_pAERO_SetResolution(nCamNo, 640, 400);
					}
				}
				else
				{
					printf("Setting resolution to VGA\r\n");
					bRet = g_pAERO_SetResolution(nCamNo, 640, 480);

				}
				if ( bRet && g_pAERO_LoadZDTable)
				{
					m_nZDTableLen = g_pAERO_LoadZDTable(m_nZDTable, 0);
					if (m_nZDTableLen > 0)
					{
						string sRes = deviceRES;
						string fname = "zdTable_"+ sRes +".txt";
						ofstream f;
						f.open(fname.c_str());
						if (!f.fail())
						{
							for (int j = 0; j < m_nZDTableLen; ++j)
							{
								string str = to_string(m_nZDTable[j]);
								f.write(str.c_str(), str.length());
								f.write("\r\n", 2);
							}
							f.close();
						}
						string info = "Explorted ZDTable to " + fname + " succesfully!";
						printf(info.c_str());
					}
					else
						printf("No ZDTable exist, or 14Bit mode is available with this device!");
				}
				else
					printf("Error resolution is not supported with this device!");
			}
			FreeLibrary(m_hAeroTAPSDK);
			m_hAeroTAPSDK = NULL;
		}
	}

    return 0;
}

